(* Haskell Session Types with (Almost) No Class
 * Riccardo Pucella and Jesse A. Tov, Haskell'08
 * http://www.ccs.neu.edu/home/tov/pubs/haskell-session-types/ *)

type epsilon
type ('r, 'a) send
type ('r, 'a) recv
type ('r, 's) choose
type ('r, 's) offer

type ('s, 't, 'a) sess

val ret   : 'a -> ('s, 's, 'a) sess

val binds : ('s, 't, 'a) sess ->
            ('a -> ('t, 'u, 'b) sess) ->
            ('s, 'u, 'b) sess

(*
val (>>)  : ('s, 't, 'a) sess ->
            ('t, 'u, 'b) sess ->
            ('s, 'u, 'b) sess


val send  : 'a -> (('r, 'a) send * ('s, 'a) recv, 'r * 's, unit) sess
val recv  : unit -> (('r, 'a) recv * ('s, 'a) send, 'r * 's, 'a) sess
val mock_recv : 'a -> (('r, 'a) recv * ('s, 'a) send, 'r * 's, 'a) sess
val sel1  : unit -> 
  (('r1, 's1) choose * ('r2, 's2) offer, 'r1 * 'r2, unit) sess
val sel2  : unit ->
  (('r1, 's1) choose * ('r2, 's2) offer, 's1 * 's2, unit) sess
val offer : (unit -> ('r1 * 'r2, 'u, 'a) sess) ->
            (unit -> ('s1 * 's2, 'u, 'a) sess) ->
            (('r1, 's1) offer * ('r2, 's2) choose, 'u, 'a) sess
val close : unit -> (epsilon * epsilon, unit, unit) sess

val run : ('r1 * 'r2, unit, 'b) sess ->
          ('r2 * 'r1, unit, 'a) sess -> 'a
*)
val send  : 'a -> (('r, 'a) send, 'r, unit) sess
val recv  : unit -> (('r, 'a) recv, 'r, 'a) sess

val print_int: int -> unit
val incr: int -> int
