(* Copyright Univ. of Maryland, College Park and Microsoft Corporation, 2011.
 * Coco is distrubited under Microsoft Public License.
 * Authors: Nataliya Guts, Michael Hicks, Nikhil Swamy, Daan Leijen.  
*)

(* Coco options *)
let quiet = ref false
let letgen = ref false
let strict = ref false
let debug = ref true
let latex = ref false
let solve = ref true

let infile = ref ""
let mli_input = ref ([]: string list)
let ml_input = ref "-"
let ml_output = ref ""
let indexed = ref true

let warning s = 
  if not !quiet then print_endline s

(* Utility functions *)
let empty = function
    [] -> true
  | _ -> false

let flat_map f l = List.flatten (List.map f l)

let split_filename x = 
  let base = Filename.chop_extension (Filename.basename x) in
  let dir = Filename.dirname x in
  dir,base

(* Set functions *)

let intersect l1 l2 =
  List.filter (fun e -> List.mem e l2) l1

let setminus l1 l2 =
  List.filter (fun e -> not (List.mem e l2)) l1

let union l1 l2 =
  l1 @ setminus l2 l1

let union_all ll = List.fold_left union [] ll


